program encryptedStream;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  System.SysUtils, System.Classes,
  GpStreams, GpStreams.DCP;

type
  TKey256 = array [1..256 div 8] of byte;

procedure TestEncrypted;
var
  enc: TGpTwofishEncryptedStream;
  fs : TFileStream;
  key: TKey256;
begin
  FillChar(key, SizeOf(key), '1');

  fs := TFileStream.Create('encrypted.bin', fmCreate);
  enc := TGpTwofishEncryptedStream.Create(key, Length(key), 222222222222222222, fs, true);

  for var b := 0 to 255 do
    enc.LE_WriteByte(b);

  FreeAndNil(enc);

  fs := TFileStream.Create('encrypted.bin', fmOpenRead);
  enc := TGpTwofishEncryptedStream.Create(key, Length(key), 222222222222222222, fs, true);

  for var i := 1 to enc.Size do
    Write(enc.LE_ReadByte, ' ');
  Writeln;

  FreeAndNil(enc);
end;

begin
  try
    try
      TestEncrypted;
    except
      on E: Exception do
        Writeln(E.ClassName, ': ', E.Message);
    end;
  finally
    Write('> ');
    Readln;
  end;
end.
