program fileStreams;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  System.SysUtils, System.Classes, System.Diagnostics;

const
  CFileSize_MB = 10;

type
  TFileStreamClass = class of TFileStream;

procedure Test(makeWriter, makeReader: TFunc<TStream>);
var
  stream: TStream;
  data: int64;
begin
  data := $123456789ABCEF;

  stream := makeWriter();
  var sw := TStopwatch.StartNew;
  for var i := 1 to CFileSize_MB * 1024 * 1024 div SizeOf(Int64) do
    stream.WriteData(data);
  sw.Stop;
  Writeln('Writer: ', sw.ElapsedMilliseconds, ' ms');
  FreeAndNil(stream);

  stream := makeReader();
  sw := TStopwatch.StartNew;
  for var i := 1 to CFileSize_MB * 1024 * 1024 div SizeOf(Int64) do
    stream.ReadData(data);
  sw.Stop;
  Writeln('Reader: ', sw.ElapsedMilliseconds, ' ms');
  FreeAndNil(stream);
end;

begin
  try
    try
      Test(
        function: TStream begin Result := TFileStream.Create('big_data.bin', fmCreate); end,
        function: TStream begin Result := TFileStream.Create('big_data.bin', fmOpenRead); end
      );

      Writeln;

      Test(
        function: TStream begin Result := TBufferedFileStream.Create('big_data.bin', fmCreate); end,
        function: TStream begin Result := TBufferedFileStream.Create('big_data.bin', fmOpenRead); end
      );
    except
      on E: Exception do
        Writeln(E.ClassName, ': ', E.Message);
    end;
  finally
    Write('> ');
    Readln;
  end;
end.
