program gpBuffer;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  System.SysUtils, System.Classes,
  GpStuff, GpStreams, GpTextStream;

procedure Test;
begin
  var b := TGpBuffer.Make('Hello');
  b.AsStream.GoToEnd;                 // TGpStreamEnhancer
  b.AsStream.WriteData(',');          // TStream
  b.Append(TGpBuffer.Make(#13#10));   // IGpBuffer
  var world := 'world';
  b.Append(@world[1], Length(world) * SizeOf(world));

  var ts := TGpTextStream.Create(b.AsStream, tsaccRead, [], CP_UNICODE);
  try
    while not ts.EOF do
      Writeln('# ', ts.Readln);
  finally FreeAndNil(ts); end;

  Writeln;

  b.ByteVal[16] := Ord('Z');          // direct access
  b.ByteVal[18] := Ord('o');
  b.ByteVal[20] := Ord('o');
  b.ByteVal[22] := Ord('m');
  b.ByteVal[24] := Ord('!');

  for var ln in EnumLines(b.AsStream, CP_UNICODE) do
    Writeln('! ', ln);

  Writeln;

  Writeln('% ', b.AsString);          // string access
end;

begin
  try
    try
      Test;
    except
      on E: Exception do
        Writeln(E.ClassName, ': ', E.Message);
    end;
  finally
    Write('> ');
    Readln;
  end;
end.
