program streamWrappers;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  System.SysUtils, System.Classes,
  GpStreams;

procedure JoinedStream;
begin
  var s1 := TBytesStream.Create(TBytes.Create(10, 11, 12, 13, 14));
  var s2 := TBytesStream.Create(TBytes.Create(20, 21, 22, 23, 24));
  var s3 := TBytesStream.Create(TBytes.Create(30, 31, 32, 33, 34));

  var js := TGpJoinedStream.Create([s1, s2, s3], true);

  for var i := 0 to js.Size - 1 do
    Write(js.LE_ReadByte, ' ');
  Writeln;

  FreeAndNil(js);
end;

procedure ScatteredStream;
begin
  var str := TBytesStream.Create(TBytes.Create(10, 11, 12, 13, 14, 20, 21, 22, 23, 24, 30, 31, 32, 33, 34));

  var scats := TGpScatteredStream.Create(str, [], true);
  scats.AddSpan(0, 2);
  scats.AddSpan(5, 7);
  scats.AddSpan(10, 12);

  for var i := 1 to scats.Size do
    Write(scats.LE_ReadByte, ' ');
  Writeln;

  FreeAndNil(scats);
end;

procedure StreamWindow;
begin
  var str := TBytesStream.Create(TBytes.Create(10, 11, 12, 13, 14, 20, 21, 22, 23, 24, 30, 31, 32, 33, 34));

  var js := TGpJoinedStream.Create(
              [ TGpStreamWindow.Create(str, 0, 2),
                TGpStreamWindow.Create(str, 10, 12),
                TGpStreamWindow.Create(str, 5, 7)
              ],
              true);

  for var i := 1 to js.Size do
    Write(js.LE_ReadByte, ' ');
  Writeln;

  FreeAndNil(js); FreeAndNil(str);
end;

begin
  try
    try
//      JoinedStream;

//      Writeln;
//      ScatteredStream;
//
//      Writeln;
      StreamWindow;
    except
      on E: Exception do
        Writeln(E.ClassName, ': ', E.Message);
    end;
  finally
    Write('> ');
    Readln;
  end;
end.
