program streams;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  System.SysUtils, System.Classes;

type
  TStreamClass = class of TStream;

procedure RunTest(writer, reader: TStream);
var
  b: byte;
  w: word;
  i: integer;
  i64: int64;
begin
  if assigned(writer) then begin
    b := $42;
    writer.WriteData(b);
    w := $1234;
    writer.WriteData(w);
    i := $5678ABCD;
    writer.WriteData(i);
    i64 := $123456789ABCDE;
    writer.WriteData(i64);
  end;

  if assigned(reader) then begin
    if assigned(writer) then
      reader.CopyFrom(writer);

    reader.Position := 0;
    while reader.Position < reader.Size do begin
      reader.ReadBuffer(b, 1);
      Write(Format('%x ', [b]));
    end;
    Writeln;
  end;
end;

procedure Test;
var
  writer, reader: TStream;
begin
//  writer := TStream.Create; reader := TStream.Create;
//  writer := TMemoryStream.Create; reader := TMemoryStream.Create;
//  writer := TBytesStream.Create; reader := TBytesStream.Create;
//  RunTest(writer, reader);
//  var bytes := Copy(TBytesStream(reader).Bytes, 0, reader.Size);
//  FreeAndNil(writer); FreeAndNil(reader);

//  writer := TFileStream.Create('data.bin', fmCreate);
//  RunTest(writer, nil);
//  FreeAndNil(writer);
//  reader := TFileStream.Create('data.bin', fmOpenRead);
//  RunTest(nil, reader);
//  FreeAndNil(reader);

  writer := TStringStream.Create('');
  RunTest(writer, nil);
  var data := TStringStream(writer).DataString;
  FreeAndNil(writer);

  reader := TStringStream.Create(data);
  RunTest(nil, reader);
  FreeAndNil(reader);
end;

begin
  try
    try
      Test;
    except
      on E: Exception do
        Writeln(E.ClassName, ': ', E.Message);
    end;
  finally
    Write('> ');
    Readln;
  end;
end.
